﻿using System;
using System.Diagnostics;
using NHibernate.Sidekick.Data.Domain;
using NHibernate.Sidekick.Utils.Validations;
using NHibernate.Validator;
using NHibernate.Validator.Constraints;

namespace NHibernate.Sidekick.ConsoleTests.Domain.Entities
{
    [DebuggerDisplay("{FirstName}")]
    public class Employee : DomainObject<Employee,  Guid>
    {
        [NotNullNotEmpty]
        [Length(255)]
        [Pattern(Regex = "[A-Za-z0-9]+")]
        public virtual string FirstName { get; set; }

        [NotNullNotEmpty]
        [Length(255)]
        [Pattern(Regex = "[A-Za-z0-9]+")]
        public virtual string LastName { get; set; }

        [Phone]
        [Length(30)]
        public virtual string Telephone { get; set; }

        [NotNull]
        public virtual Store Store { get; set; }

        public virtual DateTime Birthday { get; set;}
    }
}
