﻿using System.Collections.Generic;
using System.Diagnostics;
using NHibernate.Sidekick.Data.Domain;
using NHibernate.Validator;
using NHibernate.Validator.Constraints;

namespace NHibernate.Sidekick.ConsoleTests.Domain.Entities
{
    [DebuggerDisplay("{Name}")]
    public class Product : DomainObject<Product,  int>
    {
        [NotNullNotEmpty]
        [Length(45)]
        public virtual string Name { get; set; }

        public virtual double Price { get; set; }

        public virtual IList<Store> StoresStockedIn { get; set; }

        public Product()
        {
           StoresStockedIn = new List<Store>();
        }
    }
}